#include <sourcemod>
#include <sdktools>
#include <cstrike>
#pragma semicolon 1


#define PLUGIN_VERSION "1.5"

new Handle:tw_enabled;
new Handle:tw_mode;
new Handle:tw_bot_mode;

new Handle:tw_hs_period;
new Handle:tw_extra_period;
new Handle:tw_bomb_period;
new Handle:tw_buy_period;
new Handle:tw_kill_timescale;
new Handle:tw_bomb_timescale;
new Handle:tw_buy_timescale;

new Handle:tw_start_percent;
new Handle:tw_kill_percent;
new Handle:tw_hs_percent;
new Handle:tw_max_percent;

new Handle:tw_headshots;
new Handle:tw_killseries;
new Handle:tw_extras;
new Handle:tw_achievements;
new Handle:tw_bomb_explodes;
new Handle:tw_last_enemy;

new Handle:tw_sound;
new Handle:tw_trails;

new Handle:CheatCVAR = INVALID_HANDLE;
new Handle:BuyTime = INVALID_HANDLE;

static const String:Weapons[][]={"knife", "flashbang", "hegrenade", "smokegrenade"};

new ClientHSCount[MAXPLAYERS + 1];
new Float:LastKillTime[MAXPLAYERS + 1];
new LastKillCount[MAXPLAYERS + 1];
new Float:LastBlindTime[MAXPLAYERS + 1];
new Float:PowerPercent[MAXPLAYERS + 1];

new bool:FirstBlood=true;
new victimONGROUNG;
new TeamAliveCount[2];

new Float:trailStart[3], Float:trailEnd[3];
new trailID;

new Handle:timerSound = INVALID_HANDLE;
new Handle:timerEnd = INVALID_HANDLE;
new Float:LastPeriod;
new LastSlowdown;
new Float:LastTimescale;


public Plugin:myinfo = 
{
	name = "SM Time Warp",
	author = "EvgenKo423",
	description = "Slows down time at the different events.",
	version = PLUGIN_VERSION,
	url = "http://forums.alliedmods.net/showthread.php?p=1452823"
};

public OnPluginStart()
{
	LoadTranslations("timewarp.phrases");
	
	CreateConVar("tw_version", PLUGIN_VERSION, "SM Time Warp version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	tw_enabled = CreateConVar("tw_enabled", "1", "<0|1> Enables/Disables time warping.", FCVAR_PLUGIN);
	tw_mode = CreateConVar("tw_mode", "1", "<0|1> Sets the Time Warp's working mode. If it is 0 - Event mode. Time warp activates at simple events (like HS). If it is 1 - Skill mode. Each player has it's own probability of activating time warp.", FCVAR_PLUGIN);
	tw_bot_mode = CreateConVar("tw_bot_mode", "2", "<0|1|2> Includes/Excludes bots from activating time warp. If it is 1 - bots aren't able to activate time warp by themselves, but they are affect the player's possibilities. If 2 - bots can activate time warp by themselves.", FCVAR_PLUGIN);
	
	tw_hs_period = CreateConVar("tw_hs_period", "1.0", "Time warp period in seconds for HS kills.", FCVAR_PLUGIN);
	tw_extra_period = CreateConVar("tw_extra_period", "2.0", "Time warp period in seconds for extra events and achievements.", FCVAR_PLUGIN);
	tw_bomb_period = CreateConVar("tw_bomb_period", "1.0", "Time warp period in seconds for bomb explosions.", FCVAR_PLUGIN);
	tw_buy_period = CreateConVar("tw_buy_period", "2.0", "Time warp period in seconds at a buy time (alternative freezetime). The value of \"0.0\" disables activation at a buy time.", FCVAR_PLUGIN);
	tw_kill_timescale = CreateConVar("tw_kill_timescale", "0.5", "Time warp timescale for kills.", FCVAR_PLUGIN);
	tw_bomb_timescale = CreateConVar("tw_bomb_timescale", "0.2", "Time warp timescale for bomb explosions.", FCVAR_PLUGIN);
	tw_buy_timescale = CreateConVar("tw_buy_timescale", "0.33", "Time warp timescale for a buy time.", FCVAR_PLUGIN);
	
	tw_start_percent = CreateConVar("tw_start_percent", "0.1", "Mojo percent you start with.", FCVAR_PLUGIN);
	tw_kill_percent = CreateConVar("tw_kill_percent", "0.1", "Mojo percent you gain at simple kills (and knife hits).", FCVAR_PLUGIN);
	tw_hs_percent = CreateConVar("tw_hs_percent", "0.5", "Mojo percent you gain at HS kills.", FCVAR_PLUGIN);
	tw_max_percent = CreateConVar("tw_max_percent", "33.3", "Max mojo you can have.", FCVAR_PLUGIN);
	
	tw_headshots = CreateConVar("tw_headshots", "3", "How many HS's are needed to activate time warp (mojo percent you gain at HS series - for skill mode). 0 disables activation at HS kills.", FCVAR_PLUGIN);
	tw_killseries = CreateConVar("tw_killseries", "2", "<0|2|3|4|5> Kill series needed to activate time warp. 0 disables activation at combo kills.", FCVAR_PLUGIN);
	tw_extras = CreateConVar("tw_extras", "1", "<0|1> Enables/Disables time warp activation at extra events (like grenade kill, knife kill).", FCVAR_PLUGIN);
	tw_achievements = CreateConVar("tw_achievements", "1", "<0|1> Enables/Disables time warp activation when achievement earned.", FCVAR_PLUGIN);
	tw_bomb_explodes = CreateConVar("tw_bomb_explodes", "1", "<0|1> Enables/Disables time warp activation at bomb explosions.", FCVAR_PLUGIN);
	tw_last_enemy = CreateConVar("tw_last_enemy", "1", "<0|1> Enables/Disables time warp activation when the last player in a team has been killed.", FCVAR_PLUGIN);
	
	tw_sound = CreateConVar("tw_sounds", "2", "<0|1|2> Enables/Disables to play a sound when time warp will be (de)activated. If it is 1 - sounds will be played only for killer and victim. If 2 - sounds will be played for all players.", FCVAR_PLUGIN);
	tw_trails = CreateConVar("tw_trails", "2", "<0|1|2|3> Enables/Disables to draw bullet trails while time warp is activated. 1 - white trails, 2 - team-colored trails, 3 - random-colored trails.", FCVAR_PLUGIN);
	
	RegConsoleCmd("sm_topmojo", TopMojo, "Shows the top list of players' mojo.", FCVAR_PLUGIN);
	
	AutoExecConfig(true, "sm_timewarp");
	
	BuyTime = FindConVar("mp_freezetime");
	HookConVarChange(BuyTime, BuyTimeChanged);
	
	HookEvent("round_start", EventRoundStart, EventHookMode_PostNoCopy);
	HookEvent("bullet_impact", EventBulletImpact, EventHookMode_Pre);
	HookEvent("player_blind", EventPlayerBlind);
	HookEvent("player_hurt", EventPlayerHit);
	HookEvent("player_death", EventPlayerDeath, EventHookMode_Pre);
	HookEvent("bomb_exploded", EventBombExplode, EventHookMode_Pre);
	HookEvent("achievement_earned", EventPlayerEarnAchievement);
}

public OnMapStart()
{
	AddFileToDownloadsTable("materials/timewarp/slowdown1.vmt");
	AddFileToDownloadsTable("materials/timewarp/slowdown1.vtf");
	AddFileToDownloadsTable("materials/timewarp/slowdown2.vmt");
	AddFileToDownloadsTable("materials/timewarp/slowdown2.vtf");
	AddFileToDownloadsTable("materials/timewarp/trail.vmt");
	AddFileToDownloadsTable("materials/timewarp/trail.vtf");
	AddFileToDownloadsTable("sound/timewarp/kill.mp3");
	AddFileToDownloadsTable("sound/timewarp/death.mp3");
	AddFileToDownloadsTable("sound/timewarp/warp.wav");
	AddFileToDownloadsTable("sound/timewarp/unwarp.wav");
	
	PrecacheSound("timewarp/kill.mp3", true);
	PrecacheSound("timewarp/death.mp3", true);
	PrecacheSound("timewarp/warp.wav", true);
	PrecacheSound("timewarp/unwarp.wav", true);
	
	trailID = PrecacheModel("materials/timewarp/trail.vmt", true);
	
	new Float:start_percent = GetConVarFloat(tw_start_percent);
	PowerPercent[0] = 101.0;
	for (new i = 1; i <= MaxClients; i++) {
		ClientHSCount[i] = 0;
		LastKillTime[i] = -1.0;
		LastKillCount[i] = 0;
		LastBlindTime[i] = -1.0;
		PowerPercent[i] = start_percent + 0.0001;
	}
	CheatCVARSetup();
}

CheatCVARSetup()
{
	CheatCVAR = FindConVar("sv_cheats");
	SetConVarFlags(CheatCVAR, GetConVarFlags(CheatCVAR) & ~FCVAR_NOTIFY);
	SetConVarBool(CheatCVAR, false);
}

public BuyTimeChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (!GetConVarBool(tw_enabled) || GetConVarFloat(tw_buy_period) == 0.0)
		return;
	
	ServerCommand("mp_freezetime 0");
}

public OnClientPutInServer(client)
{
	ClientHSCount[client] = 0;
	LastKillTime[client] = -1.0;
	LastKillCount[client] = 0;
	LastBlindTime[client] = -1.0;
	PowerPercent[client] = GetConVarFloat(tw_start_percent) + 0.0001;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (impulse == 101)
		return Plugin_Handled;
	
	return Plugin_Continue;
}

public Action:TopMojo(client, args)
{
	if (!GetConVarBool(tw_enabled))
		return;
	
	if (GetConVarInt(tw_mode) != 1) {
		decl String:message[150];
		Format(message, 149, "\x03[SM Time Warp] \x01%T", "Top Mojo Unavailable", client);
		ClientPrint(client, message);
		
		return;
	}
	
	
	decl index[MaxClients + 1];
	for (new i = 0; i <= MaxClients; i++)
		index[i] = i;
	
	SortCustom1D(index, MaxClients + 1, SortByIndexDesc);
	
	
	decl String:data[2400];
	new length;
	decl String:nick[32], String:clan[16];
	
	length = Format(data, 2399, "<html><head><meta http-equiv=Content-Type content=\"text/html; charset=utf-8\">\n");
	length += Format(data[length], 2399 - length, "<style>body{font-size: 8pt; color: #FFB000} th{background-color: #FFB000; color: #000} td{padding-left: 5px} #my{color: #00A000}</style></head>\n");
	length += Format(data[length], 2399 - length, "<body scroll=no bgcolor=#000><table width=100%% cellspacing=3 border=0>\n");
	length += Format(data[length], 2399 - length, "<tr><th width=10%%>%T</th><th width=50%%>%T</th><th width=25%%>%T</th><th width=15%%>%T</th></tr>\n",
												  "Top Mojo Header Rank", client, "Top Mojo Header Nick", client, "Top Mojo Header Clan", client, "Top Mojo Header Mojo", client);
	new myIndex;
	for (new i = 1; i <= MaxClients; i++)
		if (index[i] == client) {
			myIndex = i;
			break;
		}
	
	new maxLine = (myIndex > 15? 13: (MaxClients < 15? MaxClients: 15));
	new uid;
	for (new i = 1; i <= maxLine; i++) {
		uid = index[i];
		
		if (IsClientInGame(uid)) {
			GetClientName(uid, nick, 31);
			CS_GetClientClanTag(uid, clan, 15);
			
			length += Format(data[length], 2399 - length, "<tr%s><td align=center>%u</td><td>%s</td><td>%s</td><td align=center>%3.1f%%</td></tr>\n",
														  (i == myIndex? " id=my": ""), i, nick, clan, PowerPercent[uid]);
		}
	}
	
	if (myIndex > 15) {
		uid = index[myIndex];
		
		GetClientName(uid, nick, 31);
		CS_GetClientClanTag(uid, clan, 15);
		
		length += Format(data[length], 2399 - length, "<tr><td align=center>...</td><td>...</td><td>...</td><td align=center>...</td></tr>\n");
		length += Format(data[length], 2399 - length, "<tr id=my><td align=center>%u</td><td>%s</td><td>%s</td><td align=center>%3.1f%%</td></tr>\n", myIndex, nick, clan, PowerPercent[uid]);
	}
	
	length += Format(data[length], 2399 - length, "</table></body></html>");
	
	
	decl String:stringName[11];
	Format(stringName, 10, "TopMojo%2u", client);
	
	new bool:locked = LockStringTables(false);
	new table = FindStringTable("InfoPanel");
	new dataIndex = FindStringIndex(table, stringName);
	
	if (dataIndex < 0 || dataIndex > GetStringTableMaxStrings(table))
		AddToStringTable(table, stringName, data, length);
	else
		SetStringTableData(table, dataIndex, data, length);
	LockStringTables(locked);
	
	CreateTimer(0.1, ShowTopMojo, client);
}

public SortByIndexDesc(i1, i2, const array[], Handle:hndl)
{
	if (i1 > 0 && !IsClientInGame(i1))
		return 1;
	
	if (PowerPercent[i1] > PowerPercent[i2])
		return -1;
	
	if (PowerPercent[i1] < PowerPercent[i2])
		return 1;
	
	return 0;
}

public Action:ShowTopMojo(Handle:timer, any:client)
{
	decl String:title[64];
	Format(title, 63, "%T", "Top Mojo Title", client);
	decl String:stringName[11];
	Format(stringName, 10, "TopMojo%2u", client);
	
	ShowMOTDPanel(client, title, stringName);
}

public Action:EventRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled))
		return;
	
	timerSound = INVALID_HANDLE;
	timerEnd = INVALID_HANDLE;
	
	FirstBlood = true;
	TeamAliveCount[0] = GetTeamClientCount(2);
	TeamAliveCount[1] = GetTeamClientCount(3);
	
	new Float:buy_period = GetConVarFloat(tw_buy_period);
	
	if (buy_period == 0.0)
		return;
	
	ActivateSlowdown(0, -1, buy_period, GetConVarFloat(tw_buy_timescale));
}

public Action:EventBulletImpact(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled) || !GetConVarBool(tw_achievements))
		return;
	
	new trail_mode = GetConVarInt(tw_trails);
	if (trail_mode == 0 || !GetConVarBool(CheatCVAR))
		return;
	
	new attacker = GetClientOfUserId(GetEventInt(event, "userid"));
	
	GetClientEyePosition(attacker, trailStart);
	trailStart[2] -= 2;
	
	trailEnd[0] = GetEventFloat(event, "x");
	trailEnd[1] = GetEventFloat(event, "y");
	trailEnd[2] = GetEventFloat(event, "z");
	
	new color[4] = {255,255,255,200};
	if (trail_mode == 2)
		if (GetClientTeam(attacker) == 2)
			color = {255,0,0,200};
		else
			color = {0,100,255,200};
	else if (trail_mode == 3) {
		color[0] = GetRandomInt(0, 255);
		color[1] = GetRandomInt(0, 255);
		color[2] = GetRandomInt(0, 255);
	}
	
	TE_SetupBeamPoints(trailStart, trailEnd, trailID, 0, 0, 0, 0.5, 2.0, 2.0, 2, 0.13, color, 2);
	TE_SendToAll();
}

public Action:EventPlayerBlind(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled) || !GetConVarBool(tw_achievements))
		return;
	
	new attacker = GetClientOfUserId(GetEventInt(event, "userid"));
	
	LastBlindTime[attacker] = GetEngineTime();
}

public Action:EventPlayerHit(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled) || GetConVarInt(tw_mode) == 0)
		return;
	
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	victimONGROUNG = (GetEntityFlags(victim) & FL_ONGROUND);
	
	decl String:weapon[7];
	GetEventString(event, "weapon", weapon, 6);
	
	if (StrEqual(weapon, "knife", false)) {
		new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		new bool:isAttackerValid = IsValidClient(attacker);
		
		new Float:start_percent = GetConVarFloat(tw_start_percent);
		new Float:kill_percent = GetConVarFloat(tw_kill_percent);
		
		decl String:message[80];
		
		if (GetClientTeam(attacker) == GetClientTeam(victim)) {
			PowerPercent[attacker] -= kill_percent;
			
			if (PowerPercent[attacker] <= start_percent) {
				PowerPercent[attacker] = start_percent;
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03min\x01)", "Power Percent", attacker, PowerPercent[attacker]);
			} else
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03-%3.1f%%\x01)", "Power Percent", attacker, PowerPercent[attacker], kill_percent);
			if (isAttackerValid)
				ClientPrint(attacker, message);
		} else {
			PowerPercent[attacker] += kill_percent;
			PowerPercent[victim] -= kill_percent;
			
			new Float:max_percent = GetConVarFloat(tw_max_percent);
			new bool:isVictimValid = IsValidClient(victim);
			
			if (PowerPercent[attacker] > max_percent) {
				PowerPercent[attacker] = max_percent + 0.0001;
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04max\x01)", "Power Percent", attacker, PowerPercent[attacker]);
			} else
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04+%3.1f%%\x01)", "Power Percent", attacker, PowerPercent[attacker], kill_percent);
			if (isAttackerValid)
				ClientPrint(attacker, message);
			
			if (PowerPercent[victim] <= start_percent) {
				PowerPercent[victim] = start_percent;
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03min\x01)", "Power Percent", victim, PowerPercent[victim]);
			} else
				Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03-%3.1f%%\x01)", "Power Percent", victim, PowerPercent[victim], kill_percent);
			if (isVictimValid)
				ClientPrint(victim, message);
		}
	}
}

public Action:EventPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled))
		return;
	
	new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	
	new victimTeam = GetClientTeam(victim);
	TeamAliveCount[victimTeam - 2]--;
	
	new mode = GetConVarInt(tw_mode);
	
	new bool:isAttackerValid = IsValidClient(attacker);
	new String:message[128];
	
	if (GetClientTeam(attacker) == victimTeam) {
		if (attacker != victim) {
			ClientHSCount[attacker] = 0;
			LastKillCount[attacker] = 0;
			
			if (mode == 1) {
				PowerPercent[attacker] = 0.0001;
				
				if (isAttackerValid) {
					Format(message, 127, "\x03[SM Time Warp] \x01%T 0%%", "Power Percent", attacker);
					ClientPrint(attacker, message);
				}
			}
		}
		
		return;
	}
	
	new bot_mode = GetConVarInt(tw_bot_mode);
	
	if (bot_mode == 0 && (IsFakeClient(attacker) || IsFakeClient(victim)))
		return;
	
	if (bot_mode == 1 && IsFakeClient(attacker))
		return;
	
	new bool:extras = GetConVarBool(tw_extras);
	new bool:isExtra = false;
	
	decl String:weapon[14];
	GetEventString(event, "weapon", weapon, 13);
	for (new i = 0; i < sizeof(Weapons); i++)
		if (StrEqual(weapon, Weapons[i], false)) {
			isExtra = true;
			break;
		}
	
	new Float:period = GetConVarFloat(tw_hs_period);
	new Float:extra_period = GetConVarFloat(tw_extra_period);
	
	if (extras && isExtra)
		period = extra_period;
	
	new bool:hs = GetEventBool(event, "headshot");
	new Float:tempPowerPercent = 0.000001;
	
	
	if (mode == 1) {
		tempPowerPercent += GetConVarFloat(hs? tw_hs_percent: tw_kill_percent);
		
		if (FirstBlood) {
			tempPowerPercent *= 2.0;
			FirstBlood = false;
		}
	}
	
	new hs_count = GetConVarInt(tw_headshots);
	
	if (hs_count > 0) {
		if (hs)
			ClientHSCount[attacker]++;
		
		if (hs && ClientHSCount[attacker] > 0 && ClientHSCount[attacker] <= hs_count) {
			if (ClientHSCount[attacker] < hs_count)
				Format(message, 127, "\x03[SM Time Warp] \x01%T", "HS Left", attacker, ClientHSCount[attacker], hs_count);
			else if (ClientHSCount[attacker] == hs_count)
				if (mode == 1)
					tempPowerPercent += float(hs_count);
				else
					Format(message, 127, "\x03[SM Time Warp] \x04%T", "HS Time Warp", attacker);
			if (isAttackerValid && message[0] != 0)
				ClientPrint(attacker, message);
		}
	}
	
	new combo = GetConVarInt(tw_killseries);
	
	if (combo >= 2) {
		new Float:tempLastKillTime = LastKillTime[attacker];
		LastKillTime[attacker] = GetEngineTime();
		
		if (LastKillTime[attacker] - tempLastKillTime <= 1.5) {
			LastKillCount[attacker]++;
			
			if (mode == 1)
				tempPowerPercent += (LastKillCount[attacker] == 2? 2.0: 1.0);
			if (mode == 1 || LastKillCount[attacker] >= combo)
				period = extra_period;
		} else LastKillCount[attacker] = 1;
	}
	
	new Float:hs_percent = GetConVarFloat(tw_hs_percent);
	
	if (mode == 1 && extras && isExtra)
		if (StrEqual(weapon, "knife", false))
			tempPowerPercent += hs_percent * 5.4;
		else if (StrEqual(weapon, "hegrenade", false))
			tempPowerPercent += hs_percent * 4.0;
		else tempPowerPercent += hs_percent * 20.0;
	
	new bool:achievements = GetConVarBool(tw_achievements);
	new bool:isAchievement = false;
	
	if (achievements) {
		new Handle:tracer = TR_TraceRayFilterEx(trailStart, trailEnd, MASK_SHOT_HULL, RayType_EndPoint, TraceEntityFilter, victim);
		
		if (GetEngineTime() - LastBlindTime[attacker] <= 3.0 || !(GetEntityFlags(attacker) & FL_ONGROUND)) {
			if (mode == 1)
				tempPowerPercent += hs_percent * 10.0;
			isAchievement = true;
		} else if (TR_DidHit(tracer) && !isExtra) {
			if (mode == 1)
				tempPowerPercent += hs_percent * 6.0;
			isAchievement = true;
		} else if (!victimONGROUNG) {
			if (mode == 1)
				tempPowerPercent += hs_percent * 4.0;
			isAchievement = true;
		}
		
		if (isAchievement)
			period = extra_period;
		
		CloseHandle(tracer);
	}
	
	new bool:min=false, bool:max=false;
	if (mode == 1) {
		PowerPercent[attacker] += tempPowerPercent;
		PowerPercent[victim] -= tempPowerPercent;
		
		new Float:max_percent = GetConVarFloat(tw_max_percent);
		if (PowerPercent[attacker] >= max_percent) {
			PowerPercent[attacker] = max_percent + 0.0001;
			max = true;
		}
		
		new Float:start_percent = GetConVarFloat(tw_start_percent);
		if (PowerPercent[victim] <= start_percent) {
			PowerPercent[victim] = start_percent + 0.0001;
			min = true;
		}
	}
	
	new bool:isVictimValid = IsValidClient(victim);
	
	if (mode == 1) {
		if (isAttackerValid) {
			if (max)
				Format(message, 127, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04max\x01)", "Power Percent", attacker, PowerPercent[attacker]);
			else
				Format(message, 127, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04+%3.1f%%\x01)", "Power Percent", attacker, PowerPercent[attacker], tempPowerPercent);
			ClientPrint(attacker, message);
		}
		
		if (isVictimValid) {
			if (min)
				Format(message, 127, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03min\x01)", "Power Percent", victim, PowerPercent[victim]);
			else
				Format(message, 127, "\x03[SM Time Warp] \x01%T %3.1f%% (\x03-%3.1f%%\x01)", "Power Percent", victim, PowerPercent[victim], tempPowerPercent);
			ClientPrint(victim, message);
			
			Format(message, 127, "\x03[SM Time Warp] \x01%T", "Top Mojo Info", victim);
			ClientPrint(victim, message);
		}
	}
	ClientHSCount[victim] = 0;
	
	
	new bool:canActivate = false;
	
	if (GetConVarBool(tw_last_enemy) && TeamAliveCount[victimTeam - 2] == 0) {
		period = extra_period;
		canActivate = true;
	} else if (mode == 1) {
		if (PowerPercent[attacker] >= GetRandomFloat(0.0, 100.0))
			canActivate = true;
	} else
		if ((hs_count > 0 && hs && ClientHSCount[attacker] >= hs_count) || period == extra_period)
			canActivate = true;
	
	if (canActivate) {
		if (GetConVarInt(tw_sound) > 0) {
			if (isAttackerValid)
				EmitSoundToClient(attacker, "timewarp/kill.mp3");
			
			if (isVictimValid)
				EmitSoundToClient(victim, "timewarp/death.mp3");
		}
		ActivateSlowdown(attacker, victim, period, GetConVarFloat(tw_kill_timescale));
	}
}

public Action:EventBombExplode(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled) || !GetConVarBool(tw_bomb_explodes))
		return;
	
	if (GetConVarInt(tw_sound) > 0)
		EmitSoundToAll("timewarp/death.mp3");
	ActivateSlowdown(-1, -1, GetConVarFloat(tw_bomb_period), GetConVarFloat(tw_bomb_timescale), true);
}

public Action:EventPlayerEarnAchievement(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!GetConVarBool(tw_enabled) || !GetConVarBool(tw_achievements))
		return;
	
	new player = GetClientOfUserId(GetEventInt(event, "player"));
	new bool:isPlayerValid = IsValidClient(player);
	new mode = GetConVarInt(tw_mode);
	
	if (mode == 1) {
		new Float:tempPowerPercent = GetConVarFloat(tw_hs_percent) * 10.0 + 0.000001;
		new Float:max_percent = GetConVarFloat(tw_max_percent);
		decl String:message[80];
		
		PowerPercent[player] += tempPowerPercent;
		
		if (PowerPercent[player] >= max_percent) {
			PowerPercent[player] = max_percent + 0.0001;
			Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04max\x01)", "Power Percent", player, PowerPercent[player]);
		} else
			Format(message, 79, "\x03[SM Time Warp] \x01%T %3.1f%% (\x04+%3.1f%%\x01)", "Power Percent", player, PowerPercent[player], tempPowerPercent);
		if (isPlayerValid)
			ClientPrint(player, message);
	}
	
	if (mode == 0 || PowerPercent[player] >= GetRandomFloat(0.0, 100.0)) {
		if (isPlayerValid && GetConVarInt(tw_sound) > 0)
			EmitSoundToClient(player, "timewarp/kill.mp3");
		ActivateSlowdown(player, -1, GetConVarFloat(tw_extra_period), GetConVarFloat(tw_kill_timescale));
	}
}

ActivateSlowdown(attacker, victim, Float:period, Float:timescale, bool:isBomb=false)
{
	new bool:playSound = false;
	if (GetConVarInt(tw_sound) == 2)
		playSound = true;
	
	if (timerEnd == INVALID_HANDLE) {
		SetConVarBool(CheatCVAR, true);
		ServerCommand("host_timescale %f", timescale);
		
		for (new i = 1; i <= MaxClients; i++)
			if (IsValidClient(i))
				if (attacker == 0)
					ClientCommand(i, "r_screenoverlay timewarp/slowdown2");
				else {
					ClientCommand(i, "r_screenoverlay timewarp/slowdown1");
					if (!isBomb && playSound && i != attacker && i != victim)
						EmitSoundToClient(i, "timewarp/warp.wav");
				}
		
		if (playSound)
			timerSound = CreateTimer(period - 1.300 * timescale, PlayEndSound, _, TIMER_FLAG_NO_MAPCHANGE);
		
		timerEnd = CreateTimer(period, NormalTime, _, TIMER_FLAG_NO_MAPCHANGE);
		
		LastPeriod = period;
		LastSlowdown = GetTime();
		LastTimescale = timescale;
	} else {
		if (timescale < LastTimescale) {
			ServerCommand("host_timescale %f", timescale);
			LastTimescale = timescale;
		}
		
		if ((LastPeriod - (GetTime() - LastSlowdown)) < period) {
			if (playSound) {
				new Float:newTimescale = (timescale < LastTimescale? timescale: LastTimescale);
				
				if (timerSound != INVALID_HANDLE)
					CloseHandle(timerSound);
				else if (!isBomb)
					for (new i = 1; i <= MaxClients; i++)
						if (IsValidClient(i) && i != attacker && i != victim)
							EmitSoundToClient(i, "timewarp/warp.wav");
				timerSound = CreateTimer(period - 1.300 * newTimescale, PlayEndSound, _, TIMER_FLAG_NO_MAPCHANGE);
			}
			
			CloseHandle(timerEnd);
			timerEnd = CreateTimer(period, NormalTime, _, TIMER_FLAG_NO_MAPCHANGE);
			
			LastPeriod = period;
			LastSlowdown = GetTime();
		}
	}
}

public Action:PlayEndSound(Handle:timer)
{
	for (new i = 1; i <= MaxClients; i++)
		if (IsValidClient(i))
			EmitSoundToClient(i, "timewarp/unwarp.wav");
	
	timerSound = INVALID_HANDLE;
}

public Action:NormalTime(Handle:timer)
{
	for (new i = 1; i <= MaxClients; i++)
		if (IsValidClient(i))
			ClientCommand(i, "r_screenoverlay \"\"");
	
	SetConVarBool(CheatCVAR, false);
	ServerCommand("host_timescale 1.0");
	
	timerEnd = INVALID_HANDLE;
}

public bool:TraceEntityFilter(entity, contentsMask, any:data)
{
	return false;
}

stock bool:IsValidClient(iClient)
{
	if (iClient < 1 || iClient > MaxClients)
		return false;
	
	if (!IsClientConnected(iClient) || !IsClientInGame(iClient))
		return false;
	
	return !IsFakeClient(iClient);
}

stock ClientPrint(client, String:text[])
{
	new Handle:hBuffer = StartMessageOne("SayText2", client);
	for (new i = 1; i <= MaxClients; i++)
		if (IsClientInGame(i) && GetClientTeam(i) == 2) {
			BfWriteByte(hBuffer, i);
			break;
		}
	BfWriteByte(hBuffer, true);
	BfWriteString(hBuffer, text);
	EndMessage();
}
